#!/usr/bin/python
#****************************************************************#
# ScriptName: import.py
# Author: @alibaba-inc.com
# Create Date: 2021-02-20 12:35
# Modify Author: @alibaba-inc.com
# Modify Date: 2021-02-23 12:11
# Function: 
#***************************************************************#

import sys
import os

def create_database(root_dir):
    out_file = open("create_database", "w")
    
    db_dirs = os.listdir(root_dir)
    for db_dir in db_dirs:
        path = os.path.join(root_dir, db_dir)
        if os.path.isdir(path):
            statement = "create database `" + db_dir + "`;\n"
            out_file.write(statement)

    out_file.close()

    cmd = "mysql -h " + sys.argv[2] + " -P " + sys.argv[3] + " -u " + sys.argv[4] + " -p" + sys.argv[5] + " <create_database"
    os.system(cmd)

def restore_schema(schema_file):
    cmd = "mysql -h " + sys.argv[2] + " -P " + sys.argv[3] + " -u " + sys.argv[4] + " -p" + sys.argv[5] + " <" + schema_file
    os.system(cmd)

def import_file(csv_file, db, table):
    common = "character set utf8mb4 FIELDS TERMINATED BY ',' enclosed by '\"' Escaped By '\"' lines terminated by '\\n' ignore 1 lines"

    in_file = open(csv_file, "r")
    schema = in_file.readline().strip('\n')

    load_cmd = "load data local infile '" + csv_file + "' into table `" + db + "`." + table + " " + common + " (" + schema + ");"
    load_cmd_file = csv_file + ".load"
    out_file = open(load_cmd_file, "w")
    out_file.write(load_cmd)

    in_file.close()
    out_file.close()
    cmd = "mysql -h " + sys.argv[2] + " -P " + sys.argv[3] + " -u " + sys.argv[4] + " -p" + sys.argv[5] + " <" + load_cmd_file
    os.system(cmd)

    os.remove(load_cmd_file)

def print_usage():
    print("Usage: python ./import.py [backupset_directory] [database_host] [database_port] [database_username] [database_password]")

if __name__ == '__main__':
    if len(sys.argv) != 6:
        print_usage()
        exit()

    root_dir = os.path.abspath(sys.argv[1])

    create_database(root_dir)

    schema_file = os.path.join(root_dir, "dts_ddl_tables")
    restore_schema(schema_file)

    db_dirs = os.listdir(root_dir)
    for db_dir in db_dirs:
        dir_path = os.path.join(root_dir, db_dir)
        if os.path.isdir(dir_path):
            table_dirs = os.listdir(dir_path)
            for table_dir in table_dirs:
                table_dir_path = os.path.join(dir_path, table_dir)
                if os.path.isdir(table_dir_path):
                    csv_files = os.listdir(table_dir_path)
                    for csv_file in csv_files:
                        csv_file_path = os.path.join(table_dir_path, csv_file)
                        file_size = os.path.getsize(csv_file_path)
                        if (file_size > 0):
                            import_file(csv_file_path, db_dir, table_dir)